
				'SFERA
SCREEN 12
TIMER ON
LOCATE 12, 1
COLOR 15
PRINT "Calculation of a magnetostatic field inside a Spherical Conductors System, which";
LOCATE 14, 2
PRINT "is equivalent by electromagnetic properties to a Closed and Hollow Conductor."
ON TIMER(7) GOSUB 1
DO WHILE INKEY$ = "": LOOP

1
CLS
Nl = 150      'number of lines with current in Spherical Conductor System
Nds = 50        'number of elements of current in line of SCS
DIM SG(Nds + 1), CG(Nds + 1)
C$ = "  +###.##"
Pi = 3.14159265359#
I = 10                   'SCS line current
IL = I * Nl             'current of Linear Conductor
Ndl = Nds               'number of elements of current in Linear Conductor
Rs = 20
L = Rs                  'length of Linear Conductor     strength
dl = L / Ndl
dg = 2 * Pi / Nds
ds = Rs * dg
	FOR j = 0 TO Nds - 1
	SG(j) = SIN(j * dg + dg / 2)
	CG(j) = COS(j * dg + dg / 2)
	NEXT j

LINE (500, 10)-(500, 60), 9
LOCATE 3, 64
COLOR 9
PRINT "LC"

CIRCLE (500, 110), 50, 15
LINE (500, 110)-(550, 110), 8
LOCATE 7, 66
COLOR 8
PRINT "Rs"

COLOR 5
LINE (20, 40)-(320, 40)         'X-axis
LINE (20, 105)-(320, 105)       'Y-axis
LINE (20, 165)-(320, 165)       'Z-axis
LINE (20, 230)-(320, 230)       'SCS module-axis
LINE (20, 300)-(320, 300)       'Linear current module-axis

LINE (320, 10)-(320, 350), 8, , &HFF00
LOCATE 23, 40
COLOR 8
PRINT "Rs (radius of SCS,"
LOCATE 24, 30
PRINT "along which calculates a magnetic field)"
FOR X = 0 TO Rs - 1 STEP 1
	HVx = 0
	HVy = 0
	HVz = 0
	Hs = 0
	HCx = 0
	HCy = 0
	HCz = 0
	HL = 0
	FOR v = 0 TO Nds - 1
		HUx = 0
		HUy = 0
		HUz = 0
		FOR u = 0 TO Nl - 1
		Rx = X - Rs * SG(v) * COS(u)
		Ry = -Rs * SG(v) * SIN(u)
		Rz = -Rs * CG(v)
		  R3 = (SQR(Rx * Rx + Ry * Ry + Rz * Rz)) ^ 3
		dsx = -ds * CG(v) * COS(u)
		dsy = -ds * CG(v) * SIN(u)
		dsz = ds * SG(v)
		Hsx = (dsy * Rz - Ry * dsz) / R3
		Hsy = (dsz * Rx - Rz * dsx) / R3
		Hsz = (dsx * Ry - Rx * dsy) / R3
		HUx = HUx + Hsx
		HUy = HUy + Hsy
		HUz = HUz + Hsz
	    NEXT u
	HVx = HVx + HUx
	HVy = HVy + HUy
	HVz = HVz + HUz
	Hs = SQR(HVx ^ 2 + HVy ^ 2 + HVz ^ 2)
      
		RLx = X
		'RLy = 0
		RLz = Rs + dl * v + dl / 2
		  RL3 = (SQR(RLx * RLx + RLz * RLz)) ^ 3
		'dlx = 0
		'dly = 0
		dlz = dl
		'Hlx = (dly * RLz - RLy * dlz) / RL3
		Hly = (dlz * RLx - RLz * dlx) / RL3
		'Hlz = (dlx * RLy - RLx * dly) / RL3
		'HCx = HCx + Hlx
		HCy = HCy + Hly
		'HCz = HCz + Hlz
	       
		'HL = SQR(HCx ^ 2 + HCy ^ 2 + HCz ^ 2)
		HL = HCy
	NEXT v
LOCATE 2, 1
COLOR 14
PRINT "Hsx ="; USING C$; I * HVx
PSET (X * 300 / Rs + 20, HVx + 40)

COLOR 10
LOCATE 6, 1
PRINT "Hsy ="; USING C$; I * HVy
PSET (X * 300 / Rs + 20, HVy + 105)

COLOR 11
LOCATE 10, 1
PRINT "Hsz ="; USING C$; I * HVz
PSET (X * 300 / Rs + 20, HVz + 165)

COLOR 15
LOCATE 14, 1
PRINT "Hs ="; USING C$; I * Hs
PSET (X * 300 / Rs + 20, Hs + 230)
LOCATE 14, 25
PRINT "Magnetic intensity in Spherical Conductors System (SCS)"
'LOCATE 14, 25
'PRINT "in Spherical Conductors System (SCS)"

COLOR 9
LOCATE 18, 1
PRINT "HL ="; USING C$; HL * IL * 10
PSET (X * 300 / Rs + 20, HL * IL * 10 + 300)
LOCATE 18, 25
PRINT "Magnetic intensity from Linear Conductor current (LC)"

NEXT X

FOR X = Rs TO Rs * 2 STEP 1
	HCx = 0
	HCy = 0
	HCz = 0
	HL = 0
	FOR v = 0 TO Nds - 1
		RLx = X
		'RLy = 0
		RLz = Rs + dl * v + dl / 2
		  RL3 = (SQR(RLx * RLx + RLz * RLz)) ^ 3
		'dlx = 0
		'dly = 0
		dlz = dl
		'Hlx = (dly * RLz - RLy * dlz) / RL3
		Hly = (dlz * RLx - RLz * dlx) / RL3
		'Hlz = (dlx * RLy - RLx * dly) / RL3
		'HCx = HCx + Hlx
		HCy = HCy + Hly
		'HCz = HCz + Hlz
	      
		'HL = SQR(HCx ^ 2 + HCy ^ 2 + HCz ^ 2)
		HL = HCy
	NEXT v
	PSET (X * 300 / Rs + 20, HL * IL * 10 + 300)

NEXT X

STOP

COLOR 15
	END

